#include "chdecl.h"
void CH_main_options(current, sched, cop)
#define ARGUMENTS 6
#include "chhead.h"
select: switch (SELECTOR) {
    case 0: goto c0;
    case 1: goto cb1;
    case 2: goto c2;
    case 3: goto cb6;
    case 4: goto c7;
    case 5: goto c20;
    case 6: goto c33;
    case 7: goto c56;
    case 8: goto c62;
    case 9: goto c68;
    case 10: goto c80;
    case 11: goto c94;
    case 12: goto c96;
    case 13: goto c98;
    case 14: goto c130;
    case 15: goto c143;
    case 16: goto c153;
    case 17: goto c154;
    case 18: goto c158;
    case 19: goto c160;
    case 20: goto c167;  }
c0:
/* block , 0 */
  if((ch_returncode = che_block(QUAL(0),sched)) != Normal)
     goto ch_raise_exception;
  current->ip = 1;
cb1:
/* receive 3 0 */
  if ((ch_returncode = che_receive(DEF(3),DEF(0),sched)) != Normal)
     goto ch_raise_exception;
  return;
c2:
/* copy 4 3.0 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(0).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(4).tsdr)->finalize)(REF(4).value,F_DISCARD,sched);
  REF(4).value = ch_val;
  REF(4).tsdr = & dr_table;
/* copy 5 3.1 */
  if((ch_returncode = cp_table(& ch_val, REF(3)DOT(1).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(5).tsdr)->finalize)(REF(5).value,F_DISCARD,sched);
  REF(5).value = ch_val;
  REF(5).tsdr = & dr_table;
/* chs_lit 6 , "environ" */
  if( !chs_lit(DEF(6),"environ") ) goto ch_depletion;
/* chs_lit 7 , "" */
  if( !chs_lit(DEF(7),"") ) goto ch_depletion;
  current->ip = 3;
cb6:
/* call 3.2.2 6 7 8 , 1 */
  if ((ch_returncode = che_call((
          arguments[0] = DEF(3)DOT(2)DOT(2),
          arguments[1] = DEF(6),
          arguments[2] = DEF(7),
          arguments[3] = DEF(8),
          arguments[3+1] = nil,& arguments[0]),QUAL(1),sched)) != Normal)
     goto ch_raise_exception;
  return;
c7:
/* unwrap 9 8 , 2 */
  if ((ch_returncode = che_unwrap(DEF(9),DEF(8),QUAL(2),sched)) != Normal)
     goto ch_raise_exception;
/* new_table 10 , 3 */
  if ((ch_returncode = che_new_table(DEF(10),QUAL(3),sched)) != Normal) 
     goto ch_raise_exception;
/* size 11 5 */
  REF(11).value.integer = REF(5).value.table->size;
  REF(11).tsdr = & dr_integer;
/* isubtract 12 =(97) =(65) */
  if (!chf_isubtract(DEF(12),97,65)) goto ch_depletion;
/* new_table 13 , 4 */
  if ((ch_returncode = che_new_table(DEF(13),QUAL(4),sched)) != Normal) 
     goto ch_raise_exception;
/* privatize 4 */
  if (REF(4).value.table->refcount != 1)
    if ((ch_returncode = doCopyOnWrite(DEF(4))) != Normal)
       goto ch_raise_exception;
/* initget 14 4 , 0,0 */
  (*(REF(14).tsdr)->finalize)(REF(14).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(14),DEF(4),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c20:
/* get_or_goto 14 4 , 30 */
  if ((ch_returncode = get_selected_object(DEF(14),DEF(4),sched)) != Normal)
     goto c30;
/* lookup_at 15 14 =(0) */
  if ( !((ch_t = REF(14).value.table)->size) ) goto ch_notfound;
  (*(REF(15).tsdr)->finalize)(REF(15).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(15).value,0);
  REF(15).tsdr = qdatarepmap[ch_t->tsdr->number];
/* copy 16 15 */
  REF(16) = REF(15);
/* notequal . 16 =(45) , 20 */
  if ( REF(16).value.ord_enum != 45 ) goto c20;
/* remove 17 14 4 */
  if ((ch_returncode = che_remove(DEF(17),DEF(14),DEF(4),sched)) != Normal)
     goto ch_raise_exception;
/* insert 13 17 */
  if ((ch_returncode = insertfunc(DEF(13),DEF(17),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 20 */
   goto c20;
c30:
/* endget 14 4 */
  end_selector(DEF(14),DEF(4),sched,GET);
/* copy 18 9 */
  if((ch_returncode = cp_table(& ch_val, REF(9).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(18).tsdr)->finalize)(REF(18).value,F_DISCARD,sched);
  REF(18).value = ch_val;
  REF(18).tsdr = & dr_table;
/* initget 19 18 , 0,0 */
  (*(REF(19).tsdr)->finalize)(REF(19).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(19),DEF(18),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c33:
/* get_or_goto 19 18 , 52 */
  if ((ch_returncode = get_selected_object(DEF(19),DEF(18),sched)) != Normal)
     goto c52;
/* chs_lit 20 , "+" */
  if( !chs_lit(DEF(20),"+") ) goto ch_depletion;
/* concat 21 20 19.0 */
  if ((ch_returncode = che_concat(DEF(21),DEF(20),DEF(19)DOT(0)
    ,sched)) != Normal) goto ch_raise_exception;
/* discard 20 */
  (*(REF(20).tsdr)->finalize)(REF(20).value,F_DISCARD,sched);
  REF(20).tsdr = & dr_bottom;
/* move 22 21 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22) = REF(21);
  REF(21).tsdr = & dr_bottom;
/* chs_lit 23 , "" */
  if( !chs_lit(DEF(23),"") ) goto ch_depletion;
/* equal 24 19.1 23 */
  REF(24).value.boolean = (eq_table(REF(19)DOT(1).value,REF(23).value));
  REF(24).tsdr = & dr_boolean;
/* discard 23 */
  (*(REF(23).tsdr)->finalize)(REF(23).value,F_DISCARD,sched);
  REF(23).tsdr = & dr_bottom;
/* branch_false 24 , 44 */
  if ( !REF(24).value.boolean ) goto c44;
/* insert 13 22 */
  if ((ch_returncode = insertfunc(DEF(13),DEF(22),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 50 */
   goto c50;
c44:
/* chs_lit 25 , "=" */
  if( !chs_lit(DEF(25),"=") ) goto ch_depletion;
/* concat 26 25 19.1 */
  if ((ch_returncode = che_concat(DEF(26),DEF(25),DEF(19)DOT(1)
    ,sched)) != Normal) goto ch_raise_exception;
/* discard 25 */
  (*(REF(25).tsdr)->finalize)(REF(25).value,F_DISCARD,sched);
  REF(25).tsdr = & dr_bottom;
/* concat 27 22 26 */
  if ((ch_returncode = che_concat(DEF(27),DEF(22),DEF(26),sched)) != Normal)
     goto ch_raise_exception;
/* discard 26 */
  (*(REF(26).tsdr)->finalize)(REF(26).value,F_DISCARD,sched);
  REF(26).tsdr = & dr_bottom;
/* insert 13 27 */
  if ((ch_returncode = insertfunc(DEF(13),DEF(27),FALSE,0)) != Normal)
     goto ch_raise_exception;
c50:
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
/* branch , 33 */
   goto c33;
c52:
/* endget 19 18 */
  end_selector(DEF(19),DEF(18),sched,GET);
/* discard 18 */
  (*(REF(18).tsdr)->finalize)(REF(18).value,F_DISCARD,sched);
  REF(18).tsdr = & dr_bottom;
/* copy 28 13 */
  if((ch_returncode = cp_table(& ch_val, REF(13).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  REF(28).value = ch_val;
  REF(28).tsdr = & dr_table;
/* initget 29 28 , 0,0 */
  (*(REF(29).tsdr)->finalize)(REF(29).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(29),DEF(28),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c56:
/* get_or_goto 29 28 , 160 */
  if ((ch_returncode = get_selected_object(DEF(29),DEF(28),sched)) != Normal)
     goto c160;
/* discard 22 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).tsdr = & dr_bottom;
/* new_record 30 , 2 */
  if ((ch_val.record = new_record(2)) == nil) goto ch_depletion;
  (*(REF(30).tsdr)->finalize)(REF(30).value,F_DISCARD,sched);
  REF(30).value = ch_val; REF(30).tsdr = & dr_record;
/* new_table 30.0 , 5 */
  if ((ch_returncode = che_new_table(DEF(30)DOT(0),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* block , 6 */
  if((ch_returncode = che_block(QUAL(6),sched)) != Normal)
     goto ch_raise_exception;
/* initget 31 29 , 0,0 */
  (*(REF(31).tsdr)->finalize)(REF(31).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(31),DEF(29),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c62:
/* get_or_err 31 29 */
  if ((ch_returncode = get_selected_object(DEF(31),DEF(29),sched)) != Normal)
     goto ch_raise_exception;
/* notequal . 31 =(61) , 62 */
  if ( REF(31).value.ord_enum != 61 ) goto c62;
/* new_table 32 , 5 */
  if ((ch_returncode = che_new_table(DEF(32),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* initget 33 29 , 0,0 */
  (*(REF(33).tsdr)->finalize)(REF(33).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(33),DEF(29),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c68:
/* get_or_goto 33 29 , 76 */
  if ((ch_returncode = get_selected_object(DEF(33),DEF(29),sched)) != Normal)
     goto c76;
/* position 34 33 */
  ch_frame = get_selector_frame(DEF(33),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(34).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(34).tsdr = &dr_integer;
/* position 35 31 */
  ch_frame = get_selector_frame(DEF(31),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(35).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(35).tsdr = &dr_integer;
/* ige . 34 35 , 68 */
  if ( REF(34).value.integer >= REF(35).value.integer ) goto c68;
/* copy 36 33 */
  if((ch_returncode = (REF(33).tsdr->copy)(& ch_val, REF(33).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(36).tsdr)->finalize)(REF(36).value,F_DISCARD,sched);
  REF(36).value = ch_val;
  REF(36).tsdr = datarepmap[REF(33).tsdr->number];
/* insert 32 36 */
  if ((ch_returncode = insertfunc(DEF(32),DEF(36),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 68 */
   goto c68;
c76:
/* endget 33 29 */
  end_selector(DEF(33),DEF(29),sched,GET);
/* move 22 32 */
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22) = REF(32);
  REF(32).tsdr = & dr_bottom;
/* new_table 37 , 5 */
  if ((ch_returncode = che_new_table(DEF(37),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* initget 38 29 , 0,0 */
  (*(REF(38).tsdr)->finalize)(REF(38).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(38),DEF(29),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c80:
/* get_or_goto 38 29 , 88 */
  if ((ch_returncode = get_selected_object(DEF(38),DEF(29),sched)) != Normal)
     goto c88;
/* position 39 38 */
  ch_frame = get_selector_frame(DEF(38),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(39).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(39).tsdr = &dr_integer;
/* position 40 31 */
  ch_frame = get_selector_frame(DEF(31),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(40).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(40).tsdr = &dr_integer;
/* ile . 39 40 , 80 */
  if ( REF(39).value.integer <= REF(40).value.integer ) goto c80;
/* copy 41 38 */
  if((ch_returncode = (REF(38).tsdr->copy)(& ch_val, REF(38).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(41).tsdr)->finalize)(REF(41).value,F_DISCARD,sched);
  REF(41).value = ch_val;
  REF(41).tsdr = datarepmap[REF(38).tsdr->number];
/* insert 37 41 */
  if ((ch_returncode = insertfunc(DEF(37),DEF(41),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 80 */
   goto c80;
c88:
/* endget 38 29 */
  end_selector(DEF(38),DEF(29),sched,GET);
/* move 42 37 */
  (*(REF(42).tsdr)->finalize)(REF(42).value,F_DISCARD,sched);
  REF(42) = REF(37);
  REF(37).tsdr = & dr_bottom;
/* wrap 30.1 42 , 7 */
  if ((ch_returncode = che_wrap(DEF(30)DOT(1),DEF(42),QUAL(7)
    ,sched)) != Normal) goto ch_raise_exception;
/* endget 31 29 */
  end_selector(DEF(31),DEF(29),sched,GET);
/* endblock */
  che_endblock(sched);
/* branch , 96 */
   goto c96;
c94:
/* copy 22 29 */
  if((ch_returncode = cp_table(& ch_val, REF(29).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(22).tsdr)->finalize)(REF(22).value,F_DISCARD,sched);
  REF(22).value = ch_val;
  REF(22).tsdr = & dr_table;
/* wrap 30.1 43 , 8 */
  if ((ch_returncode = che_wrap(DEF(30)DOT(1),DEF(43),QUAL(8)
    ,sched)) != Normal) goto ch_raise_exception;
c96:
/* copy 44 22 */
  if((ch_returncode = cp_table(& ch_val, REF(22).value)) != Normal)
     goto ch_raise_exception;
  (*(REF(44).tsdr)->finalize)(REF(44).value,F_DISCARD,sched);
  REF(44).value = ch_val;
  REF(44).tsdr = & dr_table;
/* initget 45 44 , 0,0 */
  (*(REF(45).tsdr)->finalize)(REF(45).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(45),DEF(44),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c98:
/* get_or_goto 45 44 , 117 */
  if ((ch_returncode = get_selected_object(DEF(45),DEF(44),sched)) != Normal)
     goto c117;
/* position 46 45 */
  ch_frame = get_selector_frame(DEF(45),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(46).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(46).tsdr = &dr_integer;
/* ile . 46 =(0) , 98 */
  if ( REF(46).value.integer <= 0 ) goto c98;
/* oege 47 45 =(65) */
  REF(47).value.boolean = (REF(45).value.ord_enum >= 65);
/* oele 48 45 =(90) */
  REF(48).value.boolean = (REF(45).value.ord_enum <= 90);
/* and 49 47 48 */
  REF(49).value.boolean = REF(47).value.boolean&REF(48).value.boolean;
  REF(49).tsdr = & dr_boolean;
/* branch_false 49 , 114 */
  if ( !REF(49).value.boolean ) goto c114;
/* oecvt_int 50 45 */
  REF(50).value.integer = REF(45).value.ord_enum;
  REF(50).tsdr = & dr_integer;
/* iadd 51 50 12 */
  if (!chf_iadd(DEF(51),REF(50).value.integer,REF(12).value.integer))
     goto ch_depletion;
/* icvt_enum 52 51 , 128 */
  if (REF(51).value.integer < 0 || REF(51).value.integer >= 128)
     goto ch_range_error;
  REF(52).value.ord_enum = REF(51).value.integer;
  REF(52).tsdr = & dr_ord_enumeration;
/* insert 30.0 52 */
  if ((ch_returncode = insertfunc(DEF(30)DOT(0),DEF(52),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 98 */
   goto c98;
c114:
/* copy 53 45 */
  REF(53) = REF(45);
/* insert 30.0 53 */
  if ((ch_returncode = insertfunc(DEF(30)DOT(0),DEF(53),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 98 */
   goto c98;
c117:
/* endget 45 44 */
  end_selector(DEF(45),DEF(44),sched,GET);
/* discard 44 */
  (*(REF(44).tsdr)->finalize)(REF(44).value,F_DISCARD,sched);
  REF(44).tsdr = & dr_bottom;
/* block , 9 */
  if((ch_returncode = che_block(QUAL(9),sched)) != Normal)
     goto ch_raise_exception;
/* boolean 54 , FALSE */
  REF(54).value.boolean = FALSE;
  REF(54).tsdr = & dr_boolean;
/* lookup_at_or_goto 55 22 =(0) , 127 */
  if ( !((ch_t = REF(22).value.table)->size) ) goto c127;
  (*(REF(55).tsdr)->finalize)(REF(55).value,F_DISCARD,sched);
  (*(ch_t->tbls[ORDER_TBL].des->lookup_at))
    (ch_t, ORDER_TBL, & REF(55).value,0);
  REF(55).tsdr = qdatarepmap[ch_t->tsdr->number];
/* notequal . 55 =(43) , 127 */
  if ( REF(55).value.ord_enum != 43 ) goto c127;
/* boolean 54 , TRUE */
  REF(54).value.boolean = TRUE;
  REF(54).tsdr = & dr_boolean;
c127:
/* branch_false 54 , 154 */
  if ( !REF(54).value.boolean ) goto c154;
/* new_table 56 , 5 */
  if ((ch_returncode = che_new_table(DEF(56),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* initget 57 30.0 , 0,0 */
  (*(REF(57).tsdr)->finalize)(REF(57).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(57),DEF(30)DOT(0),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c130:
/* get_or_goto 57 30.0 , 137 */
  if ((ch_returncode = get_selected_object(DEF(57),DEF(30)DOT(0)
    ,sched)) != Normal) goto c137;
/* position 58 57 */
  ch_frame = get_selector_frame(DEF(57),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(58).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(58).tsdr = &dr_integer;
/* ige . 58 11 , 130 */
  if ( REF(58).value.integer >= REF(11).value.integer ) goto c130;
/* copy 59 57 */
  if((ch_returncode = (REF(57).tsdr->copy)(& ch_val, REF(57).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(59).tsdr)->finalize)(REF(59).value,F_DISCARD,sched);
  REF(59).value = ch_val;
  REF(59).tsdr = datarepmap[REF(57).tsdr->number];
/* insert 56 59 */
  if ((ch_returncode = insertfunc(DEF(56),DEF(59),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 130 */
   goto c130;
c137:
/* endget 57 30.0 */
  end_selector(DEF(57),DEF(30)DOT(0),sched,GET);
/* equal 60 56 5 */
  REF(60).value.boolean = (eq_table(REF(56).value,REF(5).value));
  REF(60).tsdr = & dr_boolean;
/* discard 56 */
  (*(REF(56).tsdr)->finalize)(REF(56).value,F_DISCARD,sched);
  REF(56).tsdr = & dr_bottom;
/* branch_false 60 , 153 */
  if ( !REF(60).value.boolean ) goto c153;
/* new_table 61 , 5 */
  if ((ch_returncode = che_new_table(DEF(61),QUAL(5),sched)) != Normal) 
     goto ch_raise_exception;
/* initget 62 30.0 , 0,0 */
  (*(REF(62).tsdr)->finalize)(REF(62).value,F_DISCARD,sched);
  if ((ch_returncode = init_selector(DEF(62),DEF(30)DOT(0),nil,sched,GET,0,0
    )) != Normal) goto ch_raise_exception;
c143:
/* get_or_goto 62 30.0 , 150 */
  if ((ch_returncode = get_selected_object(DEF(62),DEF(30)DOT(0)
    ,sched)) != Normal) goto c150;
/* position 63 62 */
  ch_frame = get_selector_frame(DEF(62),sched);
  ch_t = ch_frame->inspectee->value.table;
  REF(63).value.integer = ch_frame->rmvcount +
    (*(ch_t->tbls[ORDER_TBL].des->position_of))(ch_t,ORDER_TBL,ch_frame->pos);
  REF(63).tsdr = &dr_integer;
/* ilt . 63 11 , 143 */
  if ( REF(63).value.integer < REF(11).value.integer ) goto c143;
/* copy 64 62 */
  if((ch_returncode = (REF(62).tsdr->copy)(& ch_val, REF(62).value
    )) != Normal) goto ch_raise_exception;
  (*(REF(64).tsdr)->finalize)(REF(64).value,F_DISCARD,sched);
  REF(64).value = ch_val;
  REF(64).tsdr = datarepmap[REF(62).tsdr->number];
/* insert 61 64 */
  if ((ch_returncode = insertfunc(DEF(61),DEF(64),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* branch , 143 */
   goto c143;
c150:
/* endget 62 30.0 */
  end_selector(DEF(62),DEF(30)DOT(0),sched,GET);
/* move 30.0 61 */
  (*(REF(30)DOT(0).tsdr)->finalize)(REF(30)DOT(0).value,F_DISCARD,sched);
  REF(30)DOT(0) = REF(61);
  REF(61).tsdr = & dr_bottom;
/* branch , 154 */
   goto c154;
c153:
/* exit , 10 */
  ch_e = handler_type__exit; ch_val = QUAL(10); goto ch_exception;
c154:
/* insert 10 30 */
  if ((ch_returncode = insertfunc(DEF(10),DEF(30),FALSE,0)) != Normal)
     goto ch_raise_exception;
/* endblock */
  che_endblock(sched);
/* branch , 158 */
   goto c158;
c158:
/* discard 30 */
  (*(REF(30).tsdr)->finalize)(REF(30).value,F_DISCARD,sched);
  REF(30).tsdr = & dr_bottom;
/* branch , 56 */
   goto c56;
c160:
/* endget 29 28 */
  end_selector(DEF(29),DEF(28),sched,GET);
/* discard 28 */
  (*(REF(28).tsdr)->finalize)(REF(28).value,F_DISCARD,sched);
  REF(28).tsdr = & dr_bottom;
/* move 3.3 10 */
  (*(REF(3)DOT(3).tsdr)->finalize)(REF(3)DOT(3).value,F_DISCARD,sched);
  REF(3)DOT(3) = REF(10);
  REF(10).tsdr = & dr_bottom;
/* move 3.4 4 */
  (*(REF(3)DOT(4).tsdr)->finalize)(REF(3)DOT(4).value,F_DISCARD,sched);
  REF(3)DOT(4) = REF(4);
  REF(4).tsdr = & dr_bottom;
/* return 3 */
  if (ch_caller = do_return(REF(3).value)) {
    if (ch_caller->type < CProcess) ch_caller->ip++;
      sched->wakeup_proc(sched, ch_caller);}
  else rem_return(REF(3).value);
  REF(3).tsdr = & dr_bottom;
/* endblock */
  che_endblock(sched);
c167:
/* endprocess */
  che_endprocess(sched); return;
#include "chtail.h"
